package shoppingCartTests;

import static org.junit.Assert.*;

import org.junit.After;
import org.junit.Before;
import org.junit.Test;

import shoppingCart.Product;
import shoppingCart.ProductNotFoundException;
import shoppingCart.ShoppingCart;

public class ShoppingCartTest {
	
	 private ShoppingCart cart;
	 private Product book1;

	@Before
	public void setUp(){
		cart = new ShoppingCart();		
        book1 = new Product("Pragmatic Unit Testing", 29.95);	
        cart.addItem(book1);
	}

	@After
	public void tearDownAfterClass() throws Exception {
		book1 = null;
		cart = null;
	}
	
	@Test
	public void empty() {
		cart.empty();
        assertEquals(0, cart.getItemCount());
	}

	@Test
	public void testAddItem() {
		Product book2 = new Product("Pragmatic Project Automation", 29.95);
        cart.addItem(book2);
        assertEquals(2, cart.getItemCount());
        double expectedBalance = book1.getPrice() + book2.getPrice();	
        assertEquals(expectedBalance, cart.getBalance(), 0.0);
	}

	@Test
	public void testRemoveItem() throws ProductNotFoundException{
		cart.removeItem(book1);
        assertEquals(0, cart.getItemCount());
	}

	@Test
	public void testGetItemCount() {
		 try {
	            Product book3 = new Product("Pragmatic Version Control", 29.95);
	            cart.removeItem(book3);
	            fail("Should raise a ProductNotFoundException");		    
	        } catch(ProductNotFoundException expected) {
	            // successful test
	        }
	}
}
