package scrabblePackage;
import java.awt.Color;
import java.awt.event.MouseAdapter;
import java.awt.event.MouseEvent;

import javax.swing.JButton;
import javax.swing.JLabel;

public class Board {
	public static Tile[][] playingField;

	public static void applyMultiplierTiles() {
		playingField = new Tile[Scrabble.boardSize][Scrabble.boardSize];
		Scrabble.activeLetters = new String[Scrabble.boardSize][Scrabble.boardSize];
		Scrabble.lettersOnTurn = new String[Scrabble.boardSize][Scrabble.boardSize];
		for (int c = 0; c < Scrabble.boardSize; c++) {
			for (int r = 0; r < Scrabble.boardSize; r++) {
				playingField[c][r] = makeTile(1, 1);
				Scrabble.activeLetters[c][r] = "";
			}
		}
		Tile tripleWord = makeTile(3, 1);
		Tile doubleWord = makeTile(2, 1);
		Tile tripleLetter = makeTile(1, 3);
		Tile doubleLetter = makeTile(1, 2);
		setMultiplierSquare(0, 0, tripleWord);
		setMultiplierSquare(1, 1, doubleWord);
		setMultiplierSquare(2, 2, doubleWord);
		setMultiplierSquare(3, 3, doubleWord);
		setMultiplierSquare(4, 4, doubleWord);
		setMultiplierSquare(5, 5, tripleLetter);
		setMultiplierSquare(6, 6, doubleLetter);

		setMultiplierSquare(3, 0, doubleLetter);
		setMultiplierSquare(0, 3, doubleLetter);

		setMultiplierSquare(1, 5, tripleLetter);
		setMultiplierSquare(5, 1, tripleLetter);

		setMultiplierSquare(2, 6, doubleLetter);
		setMultiplierSquare(6, 2, doubleLetter);

		setMultiplierSquare(7, 0, tripleWord);
		setMultiplierSquare(0, 7, tripleWord);
		
		setMultiplierSquare(7, 7, doubleWord);
		
		setMultiplierSquare(7, 3, doubleLetter);
		setMultiplierSquare(3, 7, doubleLetter);
	}

	private static void setMultiplierSquare(int col, int row, Tile tile) {
		playingField[col][row] = tile;
		playingField[Scrabble.boardSize-1 - col][row] = tile;
		playingField[col][Scrabble.boardSize-1 - row] = tile;
		playingField[Scrabble.boardSize-1 - col][Scrabble.boardSize-1 - row] = tile;
	}

	public static void addLetter(int x, int y) {
		Scrabble.activeLetters[x][y] = Scrabble.nextLetter;
	}

	public static void drawBoard() {
		int xPos = 0;
		int yPos = 0;
		int squareSizeHoriz = 50;
		int squareSizeVert = 30;
		for (int c = 0; c < Scrabble.boardSize; c++) {
			for (int r = 0; r < Scrabble.boardSize; r++) {
				Scrabble.tileButton = new JButton();
				Scrabble.tileButton.setName(c+":"+r);
				Scrabble.tileButton.setBackground(getTileColor(c,r));
				Scrabble.scrabble.getContentPane().add(Scrabble.tileButton);
				Scrabble.buttonArray[c][r] = Scrabble.tileButton;
				Scrabble.tileButton.setBounds(xPos, yPos, squareSizeHoriz, squareSizeVert);
				Scrabble.tileButton.addMouseListener(new MouseAdapter() {
					public void mouseReleased(MouseEvent evt) {
						if(Scrabble.gameRunning)
						tileClicked(evt);
					}
				});
				xPos += squareSizeHoriz;
			}
			yPos += squareSizeVert;
			xPos = 0;
		}
	}
	
	private static void tileClicked(MouseEvent evt) {
		JButton b = (JButton)evt.getSource();
		if(!b.isEnabled())
			return;
		JLabel playerLetters = null;
		if(Scrabble.getCurrentPlayerIndex() == 0)
			playerLetters = Scrabble.playerOneLetters;
		else
			playerLetters = Scrabble.playerTwoLetters;
		LetterInputFrame i = new LetterInputFrame(b, Scrabble.scrabble.getBounds(), playerLetters);
		i.setVisible(true);
	}
	
	private static Color getTileColor(int c, int r) {
		Tile t = Board.playingField[c][r];
		Color color = Color.WHITE;
		if(c == Scrabble.boardSize/2 && r == Scrabble.boardSize/2)
			color = Color.PINK;
		else if(t.getLetterMultiplier() == 2)
			color = Color.CYAN;
		else if(t.getLetterMultiplier() == 3)
			color = Color.BLUE;
		else if(t.getWordMultiplier() == 2)
			color = Color.MAGENTA;
		else if(t.getWordMultiplier() == 3)
			color = Color.RED;
		return color;
	}

	private static Tile makeTile(int wordMultiplier, int letterMultiplier) {
		return new Tile(wordMultiplier, letterMultiplier);
	}	
}

