package scrabblePackage;
import java.awt.Rectangle;
import java.awt.event.MouseAdapter;
import java.awt.event.MouseEvent;
import javax.swing.JButton;
import javax.swing.JLabel;
import javax.swing.JTextField;

import javax.swing.WindowConstants;

/**
 * This code was edited or generated using CloudGarden's Jigloo SWT/Swing GUI
 * Builder, which is free for non-commercial use. If Jigloo is being used
 * commercially (ie, by a corporation, company or business for any purpose
 * whatever) then you should purchase a license for each developer using Jigloo.
 * Please visit www.cloudgarden.com for details. Use of Jigloo implies
 * acceptance of these licensing terms. A COMMERCIAL LICENSE HAS NOT BEEN
 * PURCHASED FOR THIS MACHINE, SO JIGLOO OR THIS CODE CANNOT BE USED LEGALLY FOR
 * ANY CORPORATE OR COMMERCIAL PURPOSE.
 */
public class LetterInputFrame extends javax.swing.JFrame {
	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;
	private JLabel letterInputLabel;
	private JTextField letterInput;
	private JButton submit;
	private JButton target;
	private Rectangle rectangle;
	private JLabel availableLettersLabel;
	private JLabel playerLetters;
	private JButton cancelButton;
	private JLabel availableLetters;

	public LetterInputFrame(JButton b, Rectangle rectangle, JLabel playerLetters) {
		super();
		target = b;
		this.rectangle = rectangle;
		this.playerLetters = playerLetters;
		initGUI();
	}

	private void initGUI() {
		try {
			setDefaultCloseOperation(WindowConstants.DISPOSE_ON_CLOSE);
			getContentPane().setLayout(null);
			{
				letterInputLabel = new JLabel();
				getContentPane().add(letterInputLabel);
				letterInputLabel.setText("Input a Letter:");
				letterInputLabel.setBounds(34, 12, 147, 16);
			}
			{
				letterInput = new JTextField();
				getContentPane().add(letterInput);
				letterInput.setBounds(155, 10, 28, 22);
			}
			{
				submit = new JButton();
				getContentPane().add(submit);
				submit.setText("OK");
				submit.setBounds(253, 8, 86, 29);
				submit.addMouseListener(new MouseAdapter() {
					public void mouseReleased(MouseEvent evt) {
						placeTile(letterInput.getText().toUpperCase());
					}
				});
			}
			{
				availableLettersLabel = new JLabel();
				getContentPane().add(availableLettersLabel);
				availableLettersLabel.setText("Available Letters:");
				availableLettersLabel.setBounds(34, 46, 122, 16);
			}
			{
				availableLetters = new JLabel();
				getContentPane().add(availableLetters);
				availableLetters.setBounds(155, 45, 145, 16);
				availableLetters.setText(playerLetters.getText());
			}
			{
				cancelButton = new JButton();
				getContentPane().add(cancelButton);
				cancelButton.setText("Cancel");
				cancelButton.setBounds(253, 45, 86, 22);
				cancelButton.addMouseListener(new MouseAdapter() {
					public void mouseReleased(MouseEvent evt) {
						destroyMe();
					}
				});
			}
			pack();
			// this.setSize(366, 115);
			Rectangle myBounds = new Rectangle(rectangle.x + rectangle.width / 2 - 366 / 2, rectangle.y + rectangle.height / 2 - 115 / 2, 366, 115);
			this.setBounds(myBounds);
			this.setTitle("Choose A Letter");
		} catch (Exception e) {
			e.printStackTrace();
		}
	}

	protected void placeTile(String answer) {
		if (!Scrabble.racks.get(Scrabble.getCurrentPlayerIndex()).contains(answer)) {
			IncorrectLetterFrame i = new IncorrectLetterFrame(this.getBounds());
			i.setVisible(true);
			return;
		}
		// if blank do this
		String originalAnswer = answer;
		if (answer.equals("_")) {
			BlankTileFrame f = new BlankTileFrame(originalAnswer, this);
			f.setVisible(true);
		} else{
			Scrabble.exchangeButton.setVisible(false);
			placeTileFinish(answer, originalAnswer);
		}
	}

	public void placeTileFinish(String answer, String originalAnswer) {
		int colonIndex = target.getName().indexOf(':');
		int c = Integer.parseInt(target.getName().substring(0, colonIndex));
		int r = Integer.parseInt(target.getName().substring(colonIndex + 1, target.getName().length()));
		Scrabble.nextLetter = answer;
		Scrabble.getCurrentRack().remove(originalAnswer);
		Scrabble.getCurrentPlayer().displayTiles();
		PlayerActions.placeTile(c, r);
		if (Scrabble.getCurrentRack().size() == 0) {
			PlayerActions.endTurn();
			if (Scrabble.getNumberOfTilesLeft() == 0) {
				Scrabble.endGame(false);
			}
		}
		target.setText(answer);
		target.setEnabled(false);
		if(Scrabble.getNumberOfTilesLeft() == 0)
			return;
		destroyMe();
	}

	protected void destroyMe() {
		this.dispose();
	}

}
