package scrabblePackage;
import java.awt.Color;
import java.awt.event.MouseAdapter;
import java.awt.event.MouseEvent;
import java.util.ArrayList;
import java.util.Hashtable;
import java.util.Random;

import javax.swing.JButton;
import javax.swing.JLabel;

import javax.swing.WindowConstants;
import javax.swing.SwingUtilities;

/**
 * This code was edited or generated using CloudGarden's Jigloo SWT/Swing GUI
 * Builder, which is free for non-commercial use. If Jigloo is being used
 * commercially (ie, by a corporation, company or business for any purpose
 * whatever) then you should purchase a license for each developer using Jigloo.
 * Please visit www.cloudgarden.com for details. Use of Jigloo implies
 * acceptance of these licensing terms. A COMMERCIAL LICENSE HAS NOT BEEN
 * PURCHASED FOR THIS MACHINE, SO JIGLOO OR THIS CODE CANNOT BE USED LEGALLY FOR
 * ANY CORPORATE OR COMMERCIAL PURPOSE.
 */
public class Scrabble extends javax.swing.JFrame {

	// not interface items
	public static Hashtable<String, Letters> letterBag;
	public static ArrayList<player> players;

	public static boolean isFirstTurn;
	public static boolean gameRunning;

	public static ArrayList<ArrayList<String>> racks;
	public static boolean[][] visitedDown;
	public static boolean[][] visitedAcross;

	public static String[][] activeLetters;
	public static String[][] lettersOnTurn;

	public static String nextLetter;
	public static final int boardSize = 15;

	public static int nextWordMultiplier;
	public static int nextLetterMultiplier;

	public static boolean needToChallenge;

	public static Scrabble scrabble;
	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;
	private static JLabel playerTwoLabel;
	private static JLabel playerOneLabel;
	private JLabel tilesLeftLabel;
	private JLabel tilesLeft;
	private JLabel darkRed;
	private JLabel lightPink;
	private JLabel darkBlue;
	private JLabel lightBlueLabel;
	public static JButton exchangeButton;
	private JButton endGameButton;
	private JButton endTurnButton;
	public static JLabel playerTwoPoints;
	public static JLabel playerOnePoints;
	private JLabel playerTwoPointsLabel;
	private JLabel playerOnePointsLabel;
	public static JLabel playerTwoLetters;
	public static JLabel playerOneLetters;
	private JLabel playerTwoLettersLabel;
	private JLabel playerOneLettersLabel;
	public static JButton tileButton;
	public static JButton[][] buttonArray;

	/**
	 * Auto-generated main method to display this JFrame
	 */
	public static void main(String[] args) {
		SwingUtilities.invokeLater(new Runnable() {
			public void run() {
				scrabble = new Scrabble();
				scrabble.setLocationRelativeTo(null);
				scrabble.setVisible(true);
				Board.drawBoard();
			}
		});
	}

	public Scrabble() {
		
		super();
		buttonArray = new JButton[boardSize][boardSize];
		initGame();
		initGUI();
		
		//comment 1
		System.out.println("Welcome to Scrabble!");
		System.out.println("Player 1 and Player 2 take turns to enter words on " +
				"the boad.");
		System.out.println("Each word has to be joined with an already existing " +
				"word on the boad, except for the first word, which has to cover" +
				"the middle square.");
		System.out.println("Good luck!");
		//comment 2
	}

	public void initGame() {
		setupLetterBag();
		setupRacks();
		setupBoard();
		setupPlayers();
		clearTurnHistory();
		gameRunning = true;
	}

	private void initGUI() {
		try {
			setDefaultCloseOperation(WindowConstants.DISPOSE_ON_CLOSE);
			getContentPane().setLayout(null);
			this.setTitle("Scrabble");
			{
				playerOneLabel = new JLabel();
				getContentPane().add(playerOneLabel);
				playerOneLabel.setText("Player 1");
				if(getCurrentPlayerIndex() == 0)
					playerOneLabel.setForeground(Color.BLUE);
				playerOneLabel.setBounds(40, 497, 50, 16);
			}
			{
				playerTwoLabel = new JLabel();
				getContentPane().add(playerTwoLabel);
				playerTwoLabel.setText("Player 2");
				if(getCurrentPlayerIndex() == 1)
					playerTwoLabel.setForeground(Color.BLUE);
				playerTwoLabel.setBounds(485, 497, 50, 16);
			}
			{
				tilesLeftLabel = new JLabel();
				getContentPane().add(tilesLeftLabel);
				tilesLeftLabel.setText("Tiles left:");
				tilesLeftLabel.setBounds(347, 451, 70, 16);
			}
			{
				tilesLeft = new JLabel();
				getContentPane().add(tilesLeft);
				tilesLeft.setText("" + getNumberOfTilesLeft());
				tilesLeft.setBounds(403, 451, 83, 16);
			}
			{
				playerOneLettersLabel = new JLabel();
				getContentPane().add(playerOneLettersLabel);
				playerOneLettersLabel.setText("Letters:");
				playerOneLettersLabel.setBounds(40, 514, 60, 16);
			}
			{
				playerTwoLettersLabel = new JLabel();
				getContentPane().add(playerTwoLettersLabel);
				playerTwoLettersLabel.setText("Letters:");
				playerTwoLettersLabel.setBounds(485, 514, 54, 16);
			}
			{
				playerOneLetters = new JLabel();
				getContentPane().add(playerOneLetters);
				playerOneLetters.setBounds(100, 514, 137, 16);
				playerOneLetters.setText(getPlayerLetters(0));
			}
			{
				playerTwoLetters = new JLabel();
				getContentPane().add(playerTwoLetters);
				playerTwoLetters.setBounds(545, 514, 149, 16);
				playerTwoLetters.setText(getPlayerLetters(1));
			}
			{
				playerOnePointsLabel = new JLabel();
				getContentPane().add(playerOnePointsLabel);
				playerOnePointsLabel.setText("Points:");
				playerOnePointsLabel.setBounds(40, 541, 60, 16);
			}
			{
				playerTwoPointsLabel = new JLabel();
				getContentPane().add(playerTwoPointsLabel);
				playerTwoPointsLabel.setText("Points:");
				playerTwoPointsLabel.setBounds(485, 540, 54, 16);
			}
			{
				playerOnePoints = new JLabel();
				getContentPane().add(playerOnePoints);
				playerOnePoints.setBounds(105, 541, 50, 16);
				playerOnePoints.setText("" + players.get(0).pointTotal);
			}
			{
				playerTwoPoints = new JLabel();
				getContentPane().add(playerTwoPoints);
				playerTwoPoints.setBounds(537, 540, 73, 16);
				playerTwoPoints.setText("" + players.get(1).pointTotal);
			}
			{
				endTurnButton = new JButton();
				getContentPane().add(endTurnButton);
				getContentPane().add(getEndGameButton());
				getContentPane().add(getExchangeButton());
				getContentPane().add(getLightBlueLabel());
				getContentPane().add(getDarkBlue());
				getContentPane().add(getLightPink());
				getContentPane().add(getDarkRed());
				endTurnButton.setText("End Turn");
				endTurnButton.setBounds(332, 497, 87, 32);
				endTurnButton.addMouseListener(new MouseAdapter() {
					public void mouseReleased(MouseEvent evt) {
						if (gameRunning)
							PlayerActions.endTurn();
					}
				});
			}
			pack();
			this.setSize(763, 600);
		} catch (Exception e) {
			e.printStackTrace();
		}
	}

	public static void endGame(boolean forcedEnding) {
		for (int playerNumber = 0; playerNumber < players.size(); playerNumber++) {
			int totalPointsLeftInRack = getPointsLeftInRack(racks.get(playerNumber));
			players.get(playerNumber).pointTotal -= totalPointsLeftInRack;
			if (!forcedEnding) {
				getCurrentPlayer().increasePointTotal(totalPointsLeftInRack);
			}
		}
		printPlayerScores();
		gameRunning = false;
	}

	private static void printPlayerScores() {
		int player1 = players.get(0).pointTotal;
		int player2 = players.get(1).pointTotal;
		EndGameFrame e = new EndGameFrame(player1, player2, Scrabble.scrabble.getBounds());
		e.setVisible(true);
	}

	private static int getPointsLeftInRack(ArrayList<String> rack) {
		int totalPointsLeft = 0;
		for (String letter : rack) {
			totalPointsLeft += letterBag.get(letter).tileValue;
		}
		return totalPointsLeft;
	}

	public static void switchPlayer() {
		int i = getCurrentPlayerIndex();
		if (i == 0 && playerOnePoints != null){
			playerOnePoints.setText("" + getCurrentPlayer().pointTotal);
			playerOneLabel.setForeground(Color.BLACK);
			playerTwoLabel.setForeground(Color.BLUE);
		}	
		else if (playerTwoPoints != null){
			playerTwoPoints.setText("" + getCurrentPlayer().pointTotal);
			playerOneLabel.setForeground(Color.BLUE);
			playerTwoLabel.setForeground(Color.BLACK);
		}
		getCurrentPlayer().setPlayerTurn();
		i++;
		if (i > players.size() - 1)
			i = 0;
		players.get(i).setPlayerTurn();
	}

	public static player getCurrentPlayer() {
		return players.get(getCurrentPlayerIndex());
	}

	public static int getCurrentPlayerIndex() {
		for (int i = 0; i < players.size(); i++) {
			player p = players.get(i);
			if (p.playerTurn)
				return i;
		}
		return -1;
	}

	public static int getNumberOfTilesLeft() {
		int total = 0;
		for (String s : letterBag.keySet()) {
			total += letterBag.get(s).numOfTiles;
		}
		return total;
	}

	public static ArrayList<String> getCurrentRack() {
		return racks.get(getCurrentPlayerIndex());
	}

	public static void clearTurnHistory() {
		for (int c = 0; c < boardSize; c++) {
			for (int r = 0; r < boardSize; r++) {
				lettersOnTurn[c][r] = "";
				visitedAcross[c][r] = false;
				visitedDown[c][r] = false;
			}
		}
		needToChallenge = true;
		PlayerActions.wordMultiplier = 1;
		PlayerActions.wordScore = 0;
	}
	
	public static void exchangeTile(String letter){
		getCurrentRack().remove(letter);
		letterBag.get(letter).numOfTiles++;
		getCurrentPlayer().displayTiles();
	}
	
	public static void endExchangeTile(){
		int tilesMissing = 7 - Scrabble.getCurrentRack().size();
		PlayerActions.getTiles(tilesMissing);
		getCurrentPlayer().displayTiles();
		PlayerActions.endTurn();
	}

	public static void returnTilesToRack() {
		for (int c = 0; c < boardSize; c++) {
			for (int r = 0; r < boardSize; r++) {
				String letterInQuestion = lettersOnTurn[c][r];
				if (!letterInQuestion.equals("")) {
					if (letterInQuestion.contains("'")) {
						letterInQuestion = "_";
					}
					getCurrentRack().add(letterInQuestion);
					activeLetters[c][r] = "";
					Scrabble.buttonArray[c][r].setEnabled(true);
					Scrabble.buttonArray[c][r].setText(activeLetters[c][r]);
				}
			}
		}
		if(activeLetters[Math.round(boardSize/2)][Math.round(boardSize/2)].equals(""))
			isFirstTurn= true;
	}
	private String getPlayerLetters(int playerIndex) {
		String lettersString = "";
		for (String s : racks.get(playerIndex)) {
			lettersString += s + " ";
		}
		return lettersString;
	}

	private JButton getEndGameButton() {
		if (endGameButton == null) {
			endGameButton = new JButton();
			endGameButton.setText("End Game");
			endGameButton.setBounds(306, 534, 134, 22);
			endGameButton.addMouseListener(new MouseAdapter() {
				public void mouseReleased(MouseEvent evt) {
					if (gameRunning) {
						((JButton) evt.getSource()).setText("Game Ended");
						((JButton) evt.getSource()).setEnabled(false);
						endTurnButton.setVisible(false);
						endGame(true);
					}
				}
			});
		}
		return endGameButton;
	}

	private static void setupPlayers() {
		players = new ArrayList<player>();
		Random r = new Random();
		boolean b = r.nextBoolean();
		players.add(new player(b));
		players.add(new player(!b));
		PlayerActions.getTiles(7);
		PlayerActions.passTurn();
		PlayerActions.getTiles(7);
		isFirstTurn = true;
	}

	private static void setupBoard() {
		Board.applyMultiplierTiles();
		lettersOnTurn = new String[boardSize][boardSize];
		visitedAcross = new boolean[boardSize][boardSize];
		visitedDown = new boolean[boardSize][boardSize];
	}

	private static void setupRacks() {
		racks = new ArrayList<ArrayList<String>>();
		racks.add(new ArrayList<String>());
		racks.add(new ArrayList<String>());
	}

	private static void setupLetterBag() {
		letterBag = new Hashtable<String, Letters>();
		letterBag.put("A", new Letters(9, 1));
		letterBag.put("B", new Letters(2, 3));
		letterBag.put("C", new Letters(2, 3));
		letterBag.put("D", new Letters(4, 2));
		letterBag.put("E", new Letters(12, 1));
		letterBag.put("F", new Letters(2, 4));
		letterBag.put("G", new Letters(3, 2));
		letterBag.put("H", new Letters(2, 4));
		letterBag.put("I", new Letters(9, 1));
		letterBag.put("J", new Letters(1, 8));
		letterBag.put("K", new Letters(1, 5));
		letterBag.put("L", new Letters(4, 1));
		letterBag.put("M", new Letters(2, 3));
		letterBag.put("N", new Letters(6, 1));
		letterBag.put("O", new Letters(8, 1));
		letterBag.put("P", new Letters(2, 3));
		letterBag.put("Q", new Letters(1, 10));
		letterBag.put("R", new Letters(6, 1));
		letterBag.put("S", new Letters(4, 1));
		letterBag.put("T", new Letters(6, 1));
		letterBag.put("U", new Letters(4, 1));
		letterBag.put("V", new Letters(2, 4));
		letterBag.put("W", new Letters(2, 4));
		letterBag.put("X", new Letters(1, 8));
		letterBag.put("Y", new Letters(2, 4));
		letterBag.put("Z", new Letters(1, 10));
		letterBag.put("_", new Letters(2, 0));
	}
	
	private JButton getExchangeButton() {
		if(exchangeButton == null) {
			exchangeButton = new JButton();
			exchangeButton.setText("Exchange Letters");
			exchangeButton.setBounds(306, 473, 134, 23);
			exchangeButton.addMouseListener(new MouseAdapter() {
				public void mouseReleased(MouseEvent evt) {
					if (gameRunning) {
						ExchangeTilesFrame e = new ExchangeTilesFrame(scrabble.getBounds());
						e.setVisible(true);
					}
				}
			});
		}
		return exchangeButton;
	}
	
	private JLabel getLightBlueLabel() {
		if(lightBlueLabel == null) {
			lightBlueLabel = new JLabel();
			lightBlueLabel.setText("Light blue squares are double letter.");
			lightBlueLabel.setBounds(0, 451, 243, 16);
		}
		return lightBlueLabel;
	}
	
	private JLabel getDarkBlue() {
		if(darkBlue == null) {
			darkBlue = new JLabel();
			darkBlue.setText("Dark blue squares are triple letter.");
			darkBlue.setBounds(0, 471, 216, 14);
		}
		return darkBlue;
	}
	
	private JLabel getLightPink() {
		if(lightPink == null) {
			lightPink = new JLabel();
			lightPink.setText("Light pink squares are double word.");
			lightPink.setBounds(528, 451, 219, 16);
		}
		return lightPink;
	}
	
	private JLabel getDarkRed() {
		if(darkRed == null) {
			darkRed = new JLabel();
			darkRed.setText("Dark red squares are triple word.");
			darkRed.setBounds(528, 469, 210, 16);
		}
		return darkRed;
	}

}
